#!/bin/sh
# Based on instructions at http://www.a110wiki.de/wiki/Modem

KERNVER="$(uname -r)"

#121004 If drivers not present, remove init script and config file, then exit...
[ "$(ls /lib/modules/$KERNVER/agrmodem/*/* 2>/dev/null)" ] \
 || ( rm -f /etc/init.d/agrsm; \
      rm -f /etc/modprobe.d/modem_agrsm.conf; \
      rm -f /etc/modprobe.d/agrmodem.conf; \
      exit )

#110509 remove
#sleep 2 #Wait for possible add-in card..

#Select appropriate variant of the agrsm driver...
if [ "$(/sbin/lspci -n | grep ' 11c1:048[cf] ')" != "" ];then
 NEWVARIANT="048pci"
elif [ "$(/sbin/lspci -n | grep ' 11c1:06[23]0 ')" != "" ];then
 NEWVARIANT="06pci"
else
 NEWVARIANT="1040hda"
fi

#If necessary, change the variant and run depmod...
for ONEDIR in $(ls -d /lib/modules/$KERNVER/agrmodem/* 2>/dev/null);do
 if [ "$ONEDIR" = "/lib/modules/$KERNVER/agrmodem/$NEWVARIANT" ];then
  mv -f $ONEDIR/agrmodem.HIDE $ONEDIR/agrmodem.ko 2>/dev/null
  mv -f $ONEDIR/agrserial.HIDE $ONEDIR/agrserial.ko 2>/dev/null
  #110127 Uninstall init script if driver variant not present...
  [ -e $ONEDIR/agrmodem.ko -a -e $ONEDIR/agrserial.ko ] \
   || ( rm -f /etc/init.d/agrsm; \
        rm -f /etc/modprobe.d/modem_agrsm.conf; \
        rm -f /etc/modprobe.d/agrmodem.conf )
 else
  mv -f $ONEDIR/agrmodem.ko $ONEDIR/agrmodem.HIDE 2>/dev/null
  mv -f $ONEDIR/agrserial.ko $ONEDIR/agrserial.HIDE 2>/dev/null
 fi
done

[ -e /lib/modules/$KERNVER/agrmodem/$NEWVARIANT/agrmodem.ko \
 -a -e /lib/modules/$KERNVER/agrmodem/$NEWVARIANT/agrserial.ko ]; MODEXIST=$?
[ "$(grep "/agrmodem/$NEWVARIANT/agrmodem.ko:" /lib/modules/$KERNVER/modules.dep)" = "" ]; MODDEPEXIST=$?
[ $MODDEPEXIST -eq $MODEXIST ] || /sbin/depmod

###END###
